"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emptyGenericParameterMessage = exports.parseGenericParams = void 0;
const util_1 = require("@arktype/util");
const operator_js_1 = require("./string/shift/operator/operator.js");
const scanner_js_1 = require("./string/shift/scanner.js");
const parseGenericParams = (def) => _parseGenericParams(new scanner_js_1.Scanner(def));
exports.parseGenericParams = parseGenericParams;
exports.emptyGenericParameterMessage = "An empty string is not a valid generic parameter name";
const _parseGenericParams = (scanner) => {
    const param = scanner.shiftUntilNextTerminator();
    if (param === "")
        (0, util_1.throwParseError)(exports.emptyGenericParameterMessage);
    scanner.shiftUntilNonWhitespace();
    const nextNonWhitespace = scanner.shift();
    return (nextNonWhitespace === "" ? [param]
        : nextNonWhitespace === "," ? [param, ..._parseGenericParams(scanner)]
            : (0, util_1.throwParseError)((0, operator_js_1.writeUnexpectedCharacterMessage)(nextNonWhitespace, ",")));
};
