"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeMultipleLeftBoundsMessage = exports.writeUnpairableComparatorMessage = exports.writeOpenRangeMessage = exports.writeUnclosedGroupMessage = exports.writeUnmatchedGroupCloseMessage = exports.invertedComparators = exports.comparators = exports.maxComparators = exports.minComparators = void 0;
exports.minComparators = {
    ">": true,
    ">=": true
};
exports.maxComparators = {
    "<": true,
    "<=": true
};
exports.comparators = {
    ">": true,
    ">=": true,
    "<": true,
    "<=": true,
    "==": true
};
exports.invertedComparators = {
    "<": ">",
    ">": "<",
    "<=": ">=",
    ">=": "<=",
    "==": "=="
};
const writeUnmatchedGroupCloseMessage = (unscanned) => `Unmatched )${(unscanned === "" ? "" : ` before ${unscanned}`)}`;
exports.writeUnmatchedGroupCloseMessage = writeUnmatchedGroupCloseMessage;
const writeUnclosedGroupMessage = (missingChar) => `Missing ${missingChar}`;
exports.writeUnclosedGroupMessage = writeUnclosedGroupMessage;
const writeOpenRangeMessage = (min, comparator) => `Left bounds are only valid when paired with right bounds (try ...${comparator}${min})`;
exports.writeOpenRangeMessage = writeOpenRangeMessage;
const writeUnpairableComparatorMessage = (comparator) => `Left-bounded expressions must specify their limits using < or <= (was ${comparator})`;
exports.writeUnpairableComparatorMessage = writeUnpairableComparatorMessage;
const writeMultipleLeftBoundsMessage = (openLimit, openComparator, limit, comparator) => `An expression may have at most one left bound (parsed ${openLimit}${exports.invertedComparators[openComparator]}, ${limit}${exports.invertedComparators[comparator]})`;
exports.writeMultipleLeftBoundsMessage = writeMultipleLeftBoundsMessage;
