"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeInvalidDivisorMessage = exports.parseDivisor = void 0;
const util_1 = require("@arktype/util");
const parseDivisor = (s) => {
    const divisorToken = s.scanner.shiftUntilNextTerminator();
    const divisor = (0, util_1.tryParseInteger)(divisorToken, {
        errorOnFail: (0, exports.writeInvalidDivisorMessage)(divisorToken)
    });
    if (divisor === 0)
        s.error((0, exports.writeInvalidDivisorMessage)(0));
    s.root = s.root.constrain("divisor", divisor);
};
exports.parseDivisor = parseDivisor;
const writeInvalidDivisorMessage = (divisor) => `% operator must be followed by a non-zero integer literal (was ${divisor})`;
exports.writeInvalidDivisorMessage = writeInvalidDivisorMessage;
