"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.incompleteArrayTokenMessage = exports.writeUnexpectedCharacterMessage = exports.parseOperator = void 0;
const util_1 = require("@arktype/util");
const scanner_js_1 = require("../scanner.js");
const bounds_js_1 = require("./bounds.js");
const divisor_js_1 = require("./divisor.js");
const parseOperator = (s) => {
    const lookahead = s.scanner.shift();
    return (lookahead === "" ? s.finalize("")
        : lookahead === "[" ?
            s.scanner.shift() === "]" ?
                s.setRoot(s.root.array())
                : s.error(exports.incompleteArrayTokenMessage)
            : lookahead === "|" || lookahead === "&" ? s.pushRootToBranch(lookahead)
                : lookahead === ")" ? s.finalizeGroup()
                    : scanner_js_1.Scanner.lookaheadIsFinalizing(lookahead, s.scanner.unscanned) ?
                        s.finalize(lookahead)
                        : (0, util_1.isKeyOf)(lookahead, bounds_js_1.comparatorStartChars) ? (0, bounds_js_1.parseBound)(s, lookahead)
                            : lookahead === "%" ? (0, divisor_js_1.parseDivisor)(s)
                                : lookahead === " " ? (0, exports.parseOperator)(s)
                                    : s.error((0, exports.writeUnexpectedCharacterMessage)(lookahead)));
};
exports.parseOperator = parseOperator;
const writeUnexpectedCharacterMessage = (char, shouldBe = "") => `'${char}' is not allowed here${shouldBe && ` (should be ${shouldBe})`}`;
exports.writeUnexpectedCharacterMessage = writeUnexpectedCharacterMessage;
exports.incompleteArrayTokenMessage = `Missing expected ']'`;
