"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseUntilFinalizer = exports.fullStringParse = void 0;
const util_1 = require("@arktype/util");
const operator_js_1 = require("./shift/operator/operator.js");
const fullStringParse = (s) => {
    s.parseOperand();
    const result = (0, exports.parseUntilFinalizer)(s).root;
    if (!result) {
        return (0, util_1.throwInternalError)(`Root was unexpectedly unset after parsing string '${s.scanner.scanned}'`);
    }
    s.scanner.shiftUntilNonWhitespace();
    if (s.scanner.lookahead) {
        // throw a parse error if non-whitespace characters made it here without being parsed
        (0, util_1.throwParseError)((0, operator_js_1.writeUnexpectedCharacterMessage)(s.scanner.lookahead));
    }
    return result;
};
exports.fullStringParse = fullStringParse;
const parseUntilFinalizer = (s) => {
    while (s.finalizer === undefined)
        next(s);
    return s;
};
exports.parseUntilFinalizer = parseUntilFinalizer;
const next = (s) => s.hasRoot() ? s.parseOperator() : s.parseOperand();
